// Example 15 from page 15 of Java Precisely (version 1.05 of 2000-11-23)

class TLC {                                     // top-level class 
  static int sf;
  int nf;       

  static class SMC {                            // static member class
    static int ssf = sf + TLC.sf;               // can have static members
    int snf = sf + TLC.sf;                      // cannot use non-static TLC members
  }
  
  class NMC {                                   // non-static member class
    int nnf1 = sf + nf;                         // can use non-static TLC members
    int nnf2 = TLC.sf + TLC.this.nf;            // cannot have static members
  }                                             

  void nm() {                                   // non-static method in TLC
    class NLC {                                 // local class in method
      int m(final int p) { return sf+nf+p; }    // can use non-static TLC members
    }
  }
}

class Example15 {
  public static void main(String[] args) {
    TLC.SMC sio = new TLC.SMC();
    TLC.sf = 10;
    TLC oo = new TLC();
    oo.nf = 5;
    TLC.NMC io1 = oo.new NMC();
    System.out.println("io1.nnf1 = " + io1.nnf1);
    oo.nf = 7;
    TLC.NMC io2 = oo.new NMC();
    System.out.println("io1.nnf1 = " + io1.nnf1);
    System.out.println("io2.nnf1 = " + io2.nnf1);
  }
}

